/*
 * Created on 07/04/2005
 *
 */
package mbC;

import mbc.MBCSignatureFactory;
import util.Messages;
import formulasNew.Arity;
import formulasNew.Connective;
import formulasNew.ConnectiveCode;

/**
 * @author Adolfo Gustavo Serra Seca Neto
 * 
 *  
 */
public class MBCConnectives2 {

    public static final Connective OR = new Connective(Messages
            .getString("MBC.Or"), Arity.BINARY); //$NON-NLS-1$

    public Connective IMPLIES;
    public Connective CONSISTENCY;
    
    private static MBCConnectives2 __instance;

    private Connective and;

    private Connective not;

//    private Map connectives;
    
    private MBCConnectives2() {
//        connectives = new HashMap();
//        connectives.put(MBCSignatureFactory.AND, new Connective(Messages.getString("MBC.And"), Arity.BINARY));
//        connectives.put(MBCSignatureFactory.NOT, new Connective(Messages.getString("MBC.Not"), Arity.BINARY));

        IMPLIES = new Connective(Messages
                .getString("MBC.Implies"), Arity.BINARY); //$NON-NLS-1$

        CONSISTENCY = new Connective(Messages
                .getString("MBC.Consistency"), Arity.UNARY); //$NON-NLS-1$
    }

    public Connective getConnective(ConnectiveCode code) {
        if (code == MBCSignatureFactory.AND) {
            return getAnd();
        } else {
            if (code == MBCSignatureFactory.NOT) {
                return getNot();
            }
        }
        return null;
//        return (Connective) connectives.get(code);
    }

    private Connective getAnd() {
        if (and == null) {
            and = new Connective(Messages.getString("MBC.And"), Arity.BINARY); //$NON-NLS-1$
        }
        return and;
    }

    private Connective getNot() {
        if (not == null) {
            not = new Connective(Messages.getString("MBC.Not"), Arity.BINARY); //$NON-NLS-1$
        }
        return not;
    }

    public static MBCConnectives2 getInstance() {
        if (__instance == null) {
            __instance = new MBCConnectives2();
        }

        return __instance;
    }

}
