/*
 * Created on 04/08/2005
 *
 */
package logicalSystems.mbc;

import junit.framework.TestCase;
import mbC.MBCConnectives2;
import mbc.MBCConnectives;
import mbc.MBCSignatureFactory;
import formulasNew.Connective;

/**
 * @author Adolfo Gustavo Serra Seca Neto
 * 
 *
 */
public class MBCLogicSystemTest extends TestCase {
    
    
    MBCConnectives2 mbc2;
//    MBCConnectives mbc;
    
    protected void setUp() throws Exception {
        mbc2 = MBCConnectives2.getInstance();
//        mbc = MBCConnectives.getInstance();
    }

    public void testGetConnectives() {
        long begin,end;
        long total;
        
        // o mais ineficiente
        begin = System.currentTimeMillis();
        
        total =100000;
        for (int i=0; i<total; i++){
            Connective c1 = mbc2.getConnective(MBCSignatureFactory.AND);
            Connective c2 = mbc2.getConnective(MBCSignatureFactory.NOT);
        }
        
        end = System.currentTimeMillis();
        
        System.err.println (end-begin);

        total =1000000000L;

//        mbc2Or2(total);
 //       mbcConsistency(total);
        mbc2Or(total);
 //       mbcGetConsistency(total);
        mbcOr(total);
        mbcOr(total);
        mbc2Or(total);
        
        MBCConnectives.releaseMemory();
        mbcOr(total);

  
    }

//    /**
//     * @param total
//     */
//    private void mbcConsistency(long total) {
//        long begin;
//        long end;
//        System.out.println ("mbc.CONSISTENCY");
//        begin = System.currentTimeMillis();
//        
//        // esta  a melhor forma:
//        // guardar a instancia numa var
//        // e acessar o atributo da instancia
//        for (int i=0; i<total; i++){
//            Connective c1= mbc.CONSISTENCY;
//        }
//        
//        end = System.currentTimeMillis();
//        System.err.println (end-begin);
//    }
    

    /**
     * @param total
     */
    private void mbcOr(long total) {
        long begin;
        long end;
        System.out.println ("MBCOnnectives.OR");
        begin = System.currentTimeMillis();
        
        // esta  a melhor forma:
        // guardar a instancia numa var
        // e acessar o atributo da instancia
        for (int i=0; i<total; i++){
            Connective c1= MBCConnectives.OR;
        }
        
        end = System.currentTimeMillis();
        System.err.println (end-begin);
    }

//    private void mbcGetConsistency(long total){
//        long begin;
//        long end;
//        System.out.println("mbc.getConsistency()");
//        begin = System.currentTimeMillis();
//        
//        for (int i=0; i<total; i++){
//            Connective c1= mbc.getConsistency();
//        }
//        
//        end = System.currentTimeMillis();
//        System.err.println (end-begin);
//
//    }

    /**
     * @param total
     */
    private void mbc2Or(long total) {
        long begin;
        long end;
        System.out.println ("MBCConnectives2.OR");
        begin = System.currentTimeMillis();
        
        for (int i=0; i<total; i++){
            Connective c1= MBCConnectives2.OR;
        }
        
        end = System.currentTimeMillis();
        System.err.println (end-begin);
    }

    /**
     * @param total
     */
    private void mbc2Or2(long total) {
        long begin;
        long end;
        System.out.println ("mbc2.CONSISTENCY");
        begin = System.currentTimeMillis();
        
        for (int i=0; i<total; i++){
            Connective c1= mbc2.CONSISTENCY;
        }
        
        end = System.currentTimeMillis();
        System.err.println (end-begin);
    }

    public void testGetConnective() {
    }

    public void testGetRules() {
    }

    public void testGetSignature() {
    }

    public void testGetRulesStructure() {
    }

}
