/*
 * Created on 03/02/2005
 *
 */
package interfac.problem;

import java.awt.Container;
import java.awt.FlowLayout;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;


/**
 * GUI for problem loading, editing and analysing.
 * 
 * @author Adolfo Gustavo Serra Seca neto
 *
 */
public class ProblemView  extends JFrame{
    
    /**
     * 
     */
    public ProblemView() {
        
        super ("Problem View");
        
        Container container = getContentPane();
        container.setLayout(new FlowLayout());
        
        createMenu();
        
        
        
        setSize(275, 170);
        setVisible(true);
    }
    
    /**
     * 
     */
    private void createMenu() {
        
        // file menu
        JMenu fileMenu = new JMenu("File");
        fileMenu.setMnemonic('F');

        JMenuItem openItem = new JMenuItem ("Open problem file");
        openItem.setMnemonic('O');
        fileMenu.add(openItem);
        
        fileMenu.addSeparator();
        JMenuItem exitItem = new JMenuItem ("Exit");
        exitItem.setMnemonic('x');
        fileMenu.add(exitItem);

        // analyse menu
        JMenu analyseMenu = new JMenu("Analyse");
        analyseMenu.setMnemonic('A');

        
        JMenuItem analyseItem = new JMenuItem ("Analyse current problem");
        analyseItem.setMnemonic('c');
        analyseMenu.add(analyseItem);

        // help menu
        JMenu helpMenu = new JMenu("Help");
        helpMenu.setMnemonic('H');
        
        JMenuItem aboutItem = new JMenuItem ("About...");
        aboutItem.setMnemonic('A');
        helpMenu.add(aboutItem);
        
        JMenuBar bar = new JMenuBar();
        setJMenuBar(bar);
        bar.add(fileMenu);
        bar.add(analyseMenu);
        bar.add(helpMenu);
    }

    public static void main(String[] args) {
        ProblemView pv = new ProblemView();
        pv.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

}
