/*
 * Created on 15/10/2004
 *
 */
package logic.signedFormulas;

import logic.formulas.Formula;
import util.EqualsUtil;
import util.HashCodeUtil;

/**
 * Class the represents signed formulas.
 * 
 * @author Adolfo Gustavo Serra Seca Neto
 *  
 */
public class SignedFormula {

    FormulaSign _sign;

    Formula _formula;

    protected SignedFormula(FormulaSign sign, Formula formula) {
        _sign = sign;
        _formula = formula;
    }

    /**
     * @return the formula
     */
    public Formula getFormula() {
        return _formula;
    }

    /**
     * @return the sign
     */
    public FormulaSign getSign() {
        return _sign;
    }

    /** generates a string similar to the string generated by the toString method applied 
     * to an instance of this class.
     * @param fs
     * @param f
     * @return
     */
    public static String toString(FormulaSign fs, Formula f) {
        return fs.toString() + " " + f.toString();
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return toString(_sign, _formula);
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object aThat) {
        if (this == aThat)
            return true;
        // use instanceof instead of getClass here for two reasons
        // 1. if need be, it can match any supertype, and not just one class;
        // 2. it renders an explict check for "that == null" redundant, since
        // it does the check for null already - "null instanceof [type]" always
        // returns false. (See Effective Java by Joshua Bloch.)
        if (!(aThat instanceof SignedFormula))
            return false;
        // Alternative to the above line :
        // if ( aThat == null || aThat.getClass() != this.getClass() ) return
        // false;

        // cast to native object is now safe
        SignedFormula that = (SignedFormula) aThat;

        // now a proper field-by-field evaluation can be made
        return EqualsUtil.areEqual(this._sign, that._sign)
                && EqualsUtil.areEqual(this._formula, that._formula);
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#hashCode()
     */
    public int hashCode() {
        int result = HashCodeUtil.SEED;
        result = HashCodeUtil.hash(result, _sign);
        result = HashCodeUtil.hash(result, _formula);
        return result;
    }


}