/*
 * Created on 12/11/2003, 09:47:19 
 *
 */
package logic.signedFormulas;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * A class for representing lists of signed formulas. Uses Adaptor design
 * pattern.
 * 
 * @author Adolfo Neto
 *  
 */
public class SignedFormulaList {

    List _sfl;

    public SignedFormulaList() {
        _sfl = new LinkedList();
    }

    public SignedFormulaList(SignedFormula sf) {
        _sfl = new LinkedList();

        _sfl.add(sf);

    }

    public SignedFormulaList(List sfl) {
        _sfl = new LinkedList();
        _sfl.addAll(sfl);
    }

    public void add(SignedFormula sf) {
        _sfl.add(sf);
    }

    public void addAll(SignedFormulaList sfl) {
        _sfl.addAll(sfl.getList());
    }
    
    public void addAll(Collection c) {
        Iterator i = c.iterator();
        SignedFormulaList sfl = new SignedFormulaList();
        
        while(i.hasNext()){
            SignedFormula sf = (SignedFormula) i.next();
            sfl.add(sf);
        }
        
        addAll(sfl);
    }
   

    private List getList() {
        return _sfl;
    }

    public SignedFormula get(int index) {
        return (SignedFormula) _sfl.get(index);
    }

    public int size() {
        return _sfl.size();
    }

    public String toString() {
        return _sfl.toString();
    }

    public boolean contains(SignedFormula sf) {
        return _sfl.contains(sf);
    }

    public boolean remove(SignedFormula sf) {
        return _sfl.remove(sf);
    }

    public SignedFormula remove(int index) {
        return (SignedFormula) _sfl.remove(index);
    }

    public Iterator iterator() {
        return _sfl.iterator();
    }

    /**
     * @param sf
     * @param i
     */
    public void add(int i, SignedFormula sf) {
        _sfl.add(i, sf);
    }
}