/*
 * Created on 25/11/2004
 *
 */
package logic.structures;

import java.util.HashMap;
import java.util.Map;

import logic.formulas.Formula;
import logic.formulas.FormulaList;
import logic.signedFormulas.SignedFormula;

/**
 * Maps a formula and a signed formula to the list of subformulas where that
 * formula appears in the signed formula.
 * 
 * @author adolfo
 *  
 */
public class FormulaSubformulaReferencesMultiMap {

    Map _map;

    /**
     *  
     */
    public FormulaSubformulaReferencesMultiMap() {
        super();
        _map = new HashMap();
    }

    /**
     * @param f3
     * @param sf1
     * @param f1
     */
    public void put(Formula f3, SignedFormula sf1, Formula f1) {
        SignedFormula_FormulaMultimap m;
        if (_map.get(f3) == null) {
            m = new SignedFormula_FormulaMultimap();
        } else {
            m = (SignedFormula_FormulaMultimap) _map.get(f3);
        }
        m.put(sf1, f1);
        _map.put(f3, m);
    }

    /**
     * @param f3
     * @param sf1
     * @return
     */
    public FormulaList get(Formula f3, SignedFormula sf1) {
        if (_map.get(f3) == null) {
            return null;
        } else {
            SignedFormula_FormulaMultimap m = (SignedFormula_FormulaMultimap) _map.get(f3);
            return (FormulaList) m.get(sf1);
        }
    }

}