/*
 * Created on 22/10/2004
 *
 */
package logicalSystems.classicalLogic;

import logic.formulas.FormulaFactory;
import logic.signedFormulas.SignedFormula;
import logic.signedFormulas.SignedFormulaFactory;

/**
 * ClassicalSignedFormulaFactory is a Signed Formula Factory that allows the
 * creation of opposite signed formulas.
 * 
 * @author Adolfo Gustavo Serra Seca Neto
 * 
 */
public class ClassicalSignedFormulaFactory extends SignedFormulaFactory {

    public SignedFormula createOppositeSignedFormula(SignedFormula sf) {
        if (sf.getSign().equals(ClassicalSigns.TRUE)) {
            return createSignedFormula(ClassicalSigns.FALSE, sf.getFormula());
        } else
            return createSignedFormula(ClassicalSigns.TRUE, sf.getFormula());
    }

    public ClassicalSignedFormulaFactory(SignedFormulaFactory sff,
            FormulaFactory ff) {
        cloneAll(sff, ff);
    }

}
