/*
 * Created on 31/01/2005
 *  
 */
package main.aspects;


import java.util.Iterator;

import logic.formulas.Formula;
import logic.structures.FormulaSignMultimap;
import main.strategy.ClassicalProofTree;

/**
 * @author Adolfo Gustavo Serra Seca neto
 *  
 */
public aspect SizeOfAspect {

    declare parents: ClassicalProofTree implements Sizeable;

    public long ClassicalProofTree.sizeOf() {

        //        boolean _closed;
        //
        //        FormulaSignMultimap _fsmm;
        //
        //        SignedFormulaList _PBCandidates;
        //
        //        Map _signedFormulasToNodes;

        return 1 + calculateSizeOf(getFsmm())+ getPBCandidates().size()*8
                + getSignedFormulasToNodes().keySet().size()*2*7;

    }
    
    private long ClassicalProofTree.calculateSizeOf(FormulaSignMultimap fsmm){
        
        long result  = 0;
        
        Iterator i = fsmm.keySet().iterator();
        while (i.hasNext()){
            result += fsmm.get((Formula)i.next()).size()*7;
            
        }
        
        return result;
    }
    

}