/*
 * Created on 15/03/2005
 *
 */
package profiler;

import java.util.ArrayList;
import java.util.List;

import logic.problem.ProblemType;
import profiler.FamilyProblemProfile;
import util.StringUtil;

/**
 * @author Adolfo Gustavo Serra Seca Neto
 * 
 *  
 */
public class ProblemFamilyProfile {
    

    public ProblemFamilyProfile(String name, int begin, int end, int step, int base,
            ProblemType type) {
        super();
        this.name = name;
        this.begin = begin;
        this.end = end;
        this.step = step;
        this.base=base;
        this.type = type;
        this.problems = new ArrayList();
        
        for (int i=begin; i<=end; i+=step){
            problems.add (new FamilyProblemProfile(i));
        }
    }
    
    private String name;

    private int begin, end, step, base;

    private ProblemType type;
    
    private List problems;
    
    public String getProblemName(int index){
        return name + type.toString() + "_" + StringUtil.zeroes(base, index)+index;
    }

    public FamilyProblemProfile getProblem(int listIndex){
        return (FamilyProblemProfile) problems.get(listIndex);
    }

}