/*
 * Created on 21/10/2004
 *
 */
package main.proofTree;

import rules.Rule;

/**
 * Classs that represents the origins of SignedFormulaNodes.
 * 
 * @author Adolfo Gustavo Serra Seca Neto
 *  
 */
public class Origin {

    int _code;

    Rule _rule;

    SignedFormulaNode _main;

    SignedFormulaNode _auxiliary;

    /**
     * @param _rule
     * @param _main
     * @param _auxiliary
     */
    public Origin(Rule _rule, SignedFormulaNode _main,
            SignedFormulaNode _auxiliary) {
        _code = -1;
        this._rule = _rule;
        this._main = _main;
        this._auxiliary = _auxiliary;
    }
    
    public Rule getRule(){
        return _rule;
    }

    public static final Origin PROBLEM = new Origin(0);

    public static final Origin DEFINITION = new Origin(1);

    private Origin(int code) {
        _code = code;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        if (_code == 0) {
            return "Problem";
        } else if (_code == 1) {
            return "Definition";
        } else
            return "Rule: "
                    + _rule.toString()
                    + " Main: "
                    + _main.getContent()
                    + ((_auxiliary != null) ? " Auxiliary: "
                            + _auxiliary.getContent() : "");
    }

}