/*
 * Created on 21/10/2004
 *
 */
package main.proofTree;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import logic.signedFormulas.SignedFormula;

import org.jdom.Element;

/**
 * @author Adolfo Gustavo Serra Seca Neto
 * 
 */
public class SignedFormulaNode extends Node {

    SignedFormula _content;

    SignedFormulaNodeState _state;

    Origin _origin = Origin.DEFINITION;

    public SignedFormulaNode(SignedFormula sf, SignedFormulaNodeState state,
            Origin origin) {
        this._content = sf;
        this._state = state;
        this._origin = origin;
    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.Node#getContent()
     */
    public Object getContent() {
        return _content;
    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.Node#getState()
     */
    public State getState() {
        return _state;
    }

    public void setState(SignedFormulaNodeState s) {
        _state = s;
    }

    public Origin getOrigin() {
        return _origin;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return getContent() + ((getOrigin() != null) ?
        // "state: [" + getState() + "]" +
                ("   Origin: [" + getOrigin().toString() + "]") : "");
    }

    public Collection getXMLElements() {
        List l = new ArrayList();

        Element content = new Element("content");
        content.setText(getContent().toString());
        Element origin = new Element("origin");
        origin.setText(getOrigin().toString());

        l.add(content);
        l.add(origin);

        return l;

    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.Node#asXMLElement()
     */
    public Element asXMLElement() {
        Element root = new Element("node");
        root.addContent(getXMLElements());
        return root;
    }

}