/*
 * Created on 24/09/2004
 *
 */
package main.proofTree.iterator;

import main.proofTree.Node;
import main.proofTree.ProofTree;

/**
 * Iterates over the formulas of a branch backwards.
 * 
 * @author Adolfo Gustavo Serra Seca Neto
 *  
 */
public class ProofTreeBackwardLocalIterator implements ProofTreeBasicIterator {

    ProofTree pt;

    Node current;

    /**
     *  
     */
    public ProofTreeBackwardLocalIterator(ProofTree pt) {
        this.pt = pt;
        this.current = null;
    }


    /*
     * (non-Javadoc)
     * 
     * @see proofTree.ProofTreeBasicIterator#hasPrevious()
     */
    public boolean hasPrevious() {
        return (current == null && pt.getRoot() != null)
                || current.getPrevious() != null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.ProofTreeBasicIterator#previous()
     */
    public Node previous() {
        if (current == null) {
            return current = pt.getLast();
        } else
            return current = current.getPrevious();
    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.ProofTreeBasicIterator#hasNext()
     */
    public boolean hasNext() {
        return (current == null && pt.getLast() != null)
                || current.getNext() != null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.ProofTreeBasicIterator#next()
     */
    public Node next() {
        if (current == null) {
            return current = pt.getLast();
        } else
            return current = current.getNext();
    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.ProofTreeBasicIterator#current()
     */
    public Node current() {
        return current;
    }
}