/*
 * Created on 02/02/2005
 *
 */
package main.strategy;

import main.proofTree.Node;
import main.proofTree.ProofTree;

/**
 * @author Adolfo Gustavo Serra Seca neto
 * 
 */
public class NullClosedProofTree extends ProofTree implements CloseableProofTree {
    public static final NullClosedProofTree INSTANCE = new NullClosedProofTree();
    
    /*
     * (non-Javadoc)
     * 
     * @see proofTree.ProofTree#toString()
     */
    public String toString() {
        return "NullClosedProofTree.INSTANCE";
    }

    public ProofTree getParent() {
        return INSTANCE;
    }

    public ProofTree getRight() {
        return INSTANCE;
    }

    public ProofTree getLeft() {
        return INSTANCE;
    }

    /*
     * (non-Javadoc)
     * 
     * @see proofTree.ClassicalProofTree#isClosed()
     */
    public boolean isClosed() {
        return true;
    }

    /* (non-Javadoc)
     * @see proofTree.ProofTree#makeInstance(proofTree.Node)
     */
    protected ProofTree makeInstance(Node aNode) {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see proofTree.ProofTree#setOtherStructures(proofTree.ProofTree, proofTree.Node)
     */
    protected void setOtherStructures(ProofTree pt, Node aNode) {
        // TODO Auto-generated method stub
        
    }

}
