/*
 * Created on 28/09/2005
 *
 */
package main.strategy.simple.mbc;

import logic.problem.Problem;
import main.proofTree.Origin;
import main.proofTree.ProofTree;
import main.proofTree.SignedFormulaNode;
import main.proofTree.SignedFormulaNodeState;
import main.strategy.Strategy;

/**
 * Aspect for features of Simple Strategy for mbC. 
 *
 * @author Adolfo Gustavo Serra Seca Neto
 *
 */
public aspect MBCSimpleStrategyAspect {
	
	/**
	 * Aspect for overring default implementation that includes
	 * T TOP and F BOT in the Proof Tree
	 */
	ProofTree around (Strategy s, Problem p): 
		execution (ProofTree Strategy+.initialize(..)) && 
								   args(p,..) && target(s){
		if (isMBCSimpleStrategy() && isUsingSimplificationRules() &&
				p.getFormulas().size()>0){
			
			SignedFormulaNode n = new SignedFormulaNode(p.getFormulas().get(0),
					SignedFormulaNodeState.NOT_ANALYSED, Origin.PROBLEM);
			ProofTree pt = s.createPTInstance(n);
			for (int i = 1; i < p.getFormulas().size(); i++) {
				n = new SignedFormulaNode(p.getFormulas().get(i),
						SignedFormulaNodeState.NOT_ANALYSED, Origin.PROBLEM);
				pt.addLast(n);
			}
			return pt;
		}
		else{
			return proceed(s, p);
		}
	}	
	
	// TODO check whenever a proof is started if it is using MBCSimpleStrategy
	// and set a variable that is accessed here
	private boolean isMBCSimpleStrategy(){
		return false;
	}
	
	// TODO check whenever a proof is started if it is using an MBC Rules Structure
	// with simplification rules and set a variable that is accessed here
	private boolean isUsingSimplificationRules(){
		return false;
	}
	

}
