/*
 * Created on Oct 22, 2004
 *
 */
package main.tableau;

import logic.problem.Problem;
import main.proofTree.ProofTree;

import org.jdom.Element;

/**
 * @author Adolfo Gustavo Serra Seca Neto
 *  
 */
public class Proof {

    /**
     * @param _closed
     * @param _pt
     */
    public Proof(boolean _closed, ProofTree _pt, Problem p) {
        super();
        this._closed = _closed;
        this._pt = _pt;
        this._problem = p;
        
        _problemElement = _problem.asXMLElement();
        
    }

    /**
     * @param _prover
     * @param p
     */
    public Proof(Prover _prover, Problem p) {
        _problem = p;
        _problemElement = _problem.asXMLElement();
        
        Proof x = _prover.prove(p);
        _closed = x.isClosed();
        _pt = x.getProofTree();
    }

    boolean _closed;

    ProofTree _pt;

    Problem _problem;

    Execution _execution;
    
    Element _problemElement;
    

    //    Execution _execution;
    String _summary = "";

    public boolean isClosed() {
        return _closed;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        String result = showProblem() + System.getProperty("line.separator");
        result += showExecution() + System.getProperty("line.separator");
        result += _pt.toString() + System.getProperty("line.separator");

        return result;
    }

    /**
     * @return
     */
    private String showExecution() {
        return "";
    }

    /**
     * @return
     */
    private String showProblem() {
        return _problem.toString();
    }

    public String summary() {
        return _summary;
    }

    /**
     * @return
     */
    public String toStringShort() {
        return _pt.toStringShort();
    }

    /**
     * @return
     */
    public String showSize() {
        return _pt.showSize();
    }

    /**
     * @param string
     */
    public void setSummary(String string) {
        _summary = string;
    }

    /**
     * @param e
     */
    public void setExecution(Execution e) {
        _execution = e;

    }

    public Element asXMLElement() {
        Element proof = new Element("proof");

        proof.addContent(_problemElement);
        if (_execution != null){
            proof.addContent(_execution.asXMLElement());
        }
        proof.addContent(_pt.asXMLElement());

        return proof;
    }

    public ProofTree getProofTree() {
        return _pt;
    }

}