/*
 * Created on Oct 22, 2004
 *
 */
package main.tableau;

import logic.problem.Problem;
import logic.signedFormulas.SignedFormulaBuilder;
import main.proofTree.ProofTree;
import main.strategy.CloseableProofTree;
import main.strategy.Strategy;

/**
 * @author Adolfo Gustavo Serra Seca Neto
 * 
 */
public class Prover {

    Method _method;

    Strategy _strategy;

    public Strategy getStrategy() {
        return _strategy;
    }

    public void setMethod(Method m) {
        _method = m;
    }

    /**
     * @param _strategy
     *                   The _strategy to set.
     */
    public void setStrategy(Strategy _strategy) {
        this._strategy = _strategy;
    }

    public Proof prove(Problem p) {
        SignedFormulaBuilder sfb = new SignedFormulaBuilder(p
                .getSignedFormulaFactory(), p.getFormulaFactory());
        
        ProofTree pt = _strategy.close(p, sfb);
        return new Proof(((CloseableProofTree) pt).isClosed(), pt, p);
    }

}