package prooftreeviewer;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.ScrollPane;
import java.util.StringTokenizer;

import javax.swing.JApplet;
import javax.swing.JFrame;

import main.facade.TableauFacade;
import main.proofTree.ProofTree;
import main.tableau.Proof;

public class ProofTreeJFrame extends JApplet{
    Canvas c;

    ScrollPane s;

    Dimension dim = new Dimension(780, 400);

    
    ProofTree proofTree;


    public static void main(String[] args) throws Exception {
        Proof p = TableauFacade
                .runMain(configureParameters("-r instance -n php/php_4.prove"
                        + " -t normal -u -l"));
//      System.out.println(p.getProofTree());
//        System.out.println(p.getProofTree().getHeight());
//        System.out.println(p.getProofTree().getLeftHeight());
//        System.out.println(p.getProofTree().getRightHeight());
        System.out.println(p.summary());
        System.out.println(p.getProofTree().getLongestPath());
        
        JFrame myWindow = new JFrame("Graphics Applet");
        myWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        ProofTreeJFrame a = new ProofTreeJFrame(p.getProofTree());
        // myWindow.add(a); // Add to the window.

        a.init();

        myWindow.setSize(a.dim);
        // myWindow.setSize(myWindow.getMaximumSize());
        myWindow.setContentPane(a); // Add to the
                                                            // window.
        // myWindow.pack();
        myWindow.setVisible(true); // Make the window visible.
        a.repaint();

    }

    /**
     * 
     */
    public ProofTreeJFrame(ProofTree pt) {
        this.proofTree =pt;
    }

    public void init() {
        getContentPane().setLayout(new BorderLayout());
        s = new ScrollPane();
        s.setSize(100, 100);
        getContentPane().add("Center", s);
        c = new ProofTreeCanvas(proofTree, dim);
        c.setSize(dim);
        s.add(c);
    }

    public static String[] configureParameters(String parametersAsString) {
        String[] result;
        int i = 0; // index into the next empty array element

        // --- Declare and create a StringTokenizer
        StringTokenizer st;
        st = new StringTokenizer(parametersAsString);

        // --- Create an array which will hold all the tokens.
        result = new String[st.countTokens()];

        // --- Loop, getting each of the tokens
        while (st.hasMoreTokens()) {
            result[i++] = st.nextToken();
        }

        return result;
    }
    
}
