/*
 * Created on Oct 22, 2004
 *
 */
package rules.structures;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


/**
 * Class that represents a structure of lists of rules.
 * 
 * @author Adolfo Gustavo Serra Seca Neto
 *  
 */
public class RulesStructure implements IRulesStructure {

    Map _structure = new HashMap();

    public void add(String ruleListName, RuleList rl) {
        _structure.put(ruleListName, rl);
    }

    public RuleList get(String ruleListName) {
        
        if (_structure.containsKey(ruleListName)) {
            return (RuleList) _structure.get(ruleListName);
        } else
            throw new RuntimeException(
                    "No existe conjunto de regras com esse nome.");
    }

    /* (non-Javadoc)
     * @see ruleStructures.IRulesStructure#getRules()
     */
    public Collection getRules() {
        List l = new ArrayList();
        
        Iterator it = _structure.values().iterator();
        
        while (it.hasNext()){
            l.addAll(((RuleList) it.next()).asList()); 
        }
        
        return l;
    }

}